clear all;

global alpha;
global beta;
global rho;
global nu;
global T;
global S;
global r;


%----------Input parameters ----------------
S0=100; %Spot price
r=0.05; %risk free rate
%K=98; %strike 
alpha = 0.842; %alpha parameter
beta=.3; %beta parameter set from backbone or aesthetics
rho = -0.3; %rho parameter
nu = .42; %variance of volatility paramater
T=0.1; %maturity price
nsimulations=100000; %no of MC simulations (will get doubled for anithetic)
nT=50; %no. of time step points
%------------------------


%form a correlated pair of random variables for the 2 factors
rndmat1=randn(nsimulations,nT);
rndmat1=[rndmat1; -rndmat1];
rndmat2=randn(nsimulations,nT);
rndmat2=[rndmat2; -rndmat2];
rndmat2=rho*rndmat1+(1-rho*rho)^0.5*rndmat2;
nsimulations=nsimulations*2;

dt=T/(nT-1);
F0=S0*exp(r*T);

rdt=dt^0.5;
F=ones(nsimulations,1)*F0;
S=ones(nsimulations,1)*S0;
alphavec=ones(nsimulations,1)*alpha;
for i=1:nT-1,
	%dF=(r-0.5*sig*sig)*dt + sig*rdt*rndmat(:,i);
	%dS=(r-0.5*sig*sig)*dt + sig*rdt*rndmat(:,i);
	%F=F.*exp(dF);
	%S=S.*exp(dS);
	S = S + r*S*dt + alphavec.* exp(r*(beta-1)*T).*S.^beta*rdt.*rndmat1(:,i);
	%alphavec = alphavec + nu*alphavec*rdt.*rndmat2(:,i);
	alphavec = alphavec.*exp(nu*rdt.*rndmat2(:,i));
end

%badidx=find(abs(arg(S))>0);
%nBad_values=size(badidx,1) %should ideally be zero
%goodidx=find(abs(arg(S))==0);

%S=S(goodidx);
Kintervall=(70:0.5:130);
mccallprice=[];
V_BScall=[];
ivol=[];
sig=[];
for i=1:121
K=Kintervall(i)
payoff=max(S-K,0);
ivol=[ivol,impvol(exp(-r*T)*mean(payoff),exp(-r*T)*F0,K,r,0,T,0,1e-9)];
%mccallprice=[mccallprice,exp(-r*T)*mean(payoff)];

%Calculate implied volatility using Hagan's analytical formula
sig=[sig,GetSABRsigma(F0,K,alpha,beta,rho,nu,T)];
%Dest=exp(-r*T);
%d1=(log(F0/K) + 0.5*sig*sig*T)/(sig*T^0.5);
%d2=(log(F0/K) - 0.5*sig*sig*T)/(sig*T^0.5);
%V_BScall=[V_BScall,Dest*(F0*normcdf(d1)-K*normcdf(d2))]; %analytical price
end
plot(Kintervall,ivol,'+');
hold all;
plot(Kintervall,sig);
hold off;
